PaserHandler.java

  PaserHandler creates a reactive kafka Receiver to the 'initialization' topic
    - This consumer looks for both 'Start' and 'End' signals

    Start:
      - Parse path to files for gpu setup
      - Setup gpu workspaces for searching
      - Creates reactive kafka Receiver (PaserSpectraConsumerSqt.java) to handle searching spectra
      - Creates reactive kafka Receiver (PaserSpectraConsumersMs2.java) to handle writing raw data to file
      - Stores each of the above in a hashtable which can be accessed by the 'uniqueId' that the producer sends

    End:
      - accesses each of the objects created from 'Start' and frees them
    
PaserSpectraConsumerSqt.java

    Init:
      - Creates a reactive kafka Receiver to the 'Spectra' topic
      - Utilizes 2 threads to handle searching Spectra
      - The reference to thread specific objects is stored in arrays that are accessed by the threads name

    Free:
      - Once end signal has been detected PaserHandler calls free on PaserSpectraConsumerSqt receivor/scheduler
      - To avoid stopping before messages are done being consumed, the free method waits until no message has been consumed in 5 seconds
        - at this point the receiver is disposed

  

