package com.ip2.api;

import org.apache.hc.client5.http.impl.classic.CloseableHttpClient;
import org.apache.hc.client5.http.impl.classic.HttpClients;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.util.Properties;

public class Ip2Constants {

    private static Ip2Constants instance = null;

    private final CloseableHttpClient httpClient = HttpClients.createDefault();

    private String scheme = "";

    private String host = "";

    private String searchInfoFilePath = "";

    private String securityCode = "";

    private boolean authenticated = false;

    private String validatePath = "/validate.html";

    private String projectPath = "/projects.html";

    private String searchParamPath = "/search-params.html";

    private String createSearchPath = "/create-search.html";

    private String searchDetailsPath = "get-search-details.html";

    private String massSpectInstrumentPath = "/mass-instruments.html";

    private String submitDtaJobPath = "/run-dta-job.html";

    public static Ip2Constants getInstance() {

        if (instance == null) {

            instance = new Ip2Constants();

            instance.init();
        }
        return instance;
    }

    private void init() {

        File propertyFile = new File("ip2.properties");

        try (InputStream input = new FileInputStream(propertyFile.getCanonicalPath());) {

            Properties prop = new Properties();
            prop.load(input);
            this.scheme = prop.getProperty("scheme");
            this.host = prop.getProperty("host");
            this.searchInfoFilePath =  prop.getProperty("search-info-file-path");

        } catch (IOException ex) {
            ex.printStackTrace();
        }
    }

    private Ip2Constants() {

    }

    public String getScheme() {
        return scheme;
    }

    public void setScheme(String scheme) {
        this.scheme = scheme;
    }

    public String getHost() {
        return host;
    }

    public void setHost(String host) {
        this.host = host;
    }

    public static void main(String[] args) {

        Ip2Constants.getInstance();
    }

    public String getSecurityCode() {
        return securityCode;
    }

    public void setSecurityCode(String securityCode) {
        this.securityCode = securityCode;
    }

    public String getValidatePath() {
        return validatePath;
    }

    public void setValidatePath(String validatePath) {
        this.validatePath = validatePath;
    }

    public String getProjectPath() {
        return projectPath;
    }

    public String getMassSpectInstrumentPath() {
        return massSpectInstrumentPath;
    }

    public void setMassSpectInstrumentPath(String massSpectInstrumentPath) {
        this.massSpectInstrumentPath = massSpectInstrumentPath;
    }

    public void setProjectPath(String projectPath) {
        this.projectPath = projectPath;
    }

    public String getSearchParamPath() {
        return searchParamPath;
    }

    public void setSearchParamPath(String searchParamPath) {
        this.searchParamPath = searchParamPath;
    }

    public CloseableHttpClient getHttpClient() {
        return httpClient;
    }

    public boolean isAuthenticated() {
        return authenticated;
    }

    public void setAuthenticated(boolean authenticated) {
        this.authenticated = authenticated;
    }

    public String getCreateSearchPath() {
        return createSearchPath;
    }

    public void setCreateSearchPath(String createSearchPath) {
        this.createSearchPath = createSearchPath;
    }

    public String getSearchDetailsPath() {
        return searchDetailsPath;
    }

    public void setSearchDetailsPath(String searchDetailsPath) {
        this.searchDetailsPath = searchDetailsPath;
    }

    public String getSearchInfoFilePath() {
        return searchInfoFilePath;
    }

    public void setSearchInfoFilePath(String searchInfoFilePath) {
        this.searchInfoFilePath = searchInfoFilePath;
    }

    public String getSubmitDtaJobPath() {
        return submitDtaJobPath;
    }

    public void setSubmitDtaJobPath(String submitDtaJobPath) {
        this.submitDtaJobPath = submitDtaJobPath;
    }

    @Override
    public String toString() {
        return "Ip2Constants{" +
                "scheme='" + scheme + '\'' +
                ", host='" + host + '\'' +
                '}';
    }
}
