package com.ip2.api;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.util.Properties;

public class Ip2PaserConstants{

    private static Ip2PaserConstants instance = null;

    private String userName = null;

    private String password = null;

    private String ptxFileLocation = null;

    public static Ip2PaserConstants getInstance() {

        if (instance == null) {

            instance = new Ip2PaserConstants();

            instance.init();
        }
        return instance;
    }

    private void init(){

        File propertyFile = new File("ip2.properties");

        try (InputStream input = new FileInputStream(propertyFile.getCanonicalPath());) {

            Properties prop = new Properties();
            prop.load(input);
            this.userName = prop.getProperty("ip2_user");
            this.password = prop.getProperty("ip2_user_password");
            this.ptxFileLocation =  prop.getProperty("ptx_file_location");

        } catch (IOException ex) {
            ex.printStackTrace();
        }
    }

    public String getUserName() {
        return userName;
    }

    public void setUserName(String userName) {
        this.userName = userName;
    }

    public String getPassword() {
        return password;
    }

    public void setPassword(String password) {
        this.password = password;
    }

    public String getPtxFileLocation() {
        return ptxFileLocation;
    }

    public void setPtxFileLocation(String ptxFileLocation) {
        this.ptxFileLocation = ptxFileLocation;
    }

    private Ip2PaserConstants(){

    }
}
