package com.ip2.api.controller;

import com.google.gson.Gson;
import com.ip2.api.Ip2Constants;
import com.ip2.api.bo.Ip2Security;
import com.ip2.api.util.Ip2HttpUtil;
import org.apache.log4j.Logger;

import java.net.URI;
import java.net.URISyntaxException;

public class AccountController {

    private static Logger logger = Logger.getLogger(AccountController.class);

    private Ip2HttpUtil ip2HttpUtil = new Ip2HttpUtil();

    public void authenticate(String username, String password) {

        try {

            URI uri = ip2HttpUtil.getURIBuilder().setPath(Ip2Constants.getInstance().getValidatePath())
                    .setParameter("userName", username)
                    .setParameter("password", password).build();

            String securityCode = ip2HttpUtil.getUriResponse(uri);

            Ip2Security ip2Security = new Gson().fromJson(securityCode, Ip2Security.class);

            if(ip2Security.getSecurityCode() != null && !ip2Security.getSecurityCode().equals("not-valid") ){
                Ip2Constants.getInstance().setAuthenticated(true);
            }else{
                Ip2Constants.getInstance().setAuthenticated(false);
            }

            Ip2Constants.getInstance().setSecurityCode(ip2Security.getSecurityCode());

            logger.debug("securityCode :: " + Ip2Constants.getInstance().getSecurityCode());

        } catch (URISyntaxException e) {
            e.printStackTrace();
        }

    }

    public static void main(String[] args) {
        AccountController accountController = new AccountController();
        accountController.authenticate("ip2test", "ip2test321");
    }
}
