package com.ip2.api.controller;

import com.google.gson.Gson;
import com.ip2.api.Ip2Constants;
import com.ip2.api.bo.Ip2Response;
import com.ip2.api.bo.Ip2Security;
import com.ip2.api.util.Ip2HttpUtil;
import org.apache.log4j.Logger;

import java.net.URI;
import java.net.URISyntaxException;

public class DTAJobController {

    private static Logger logger = Logger.getLogger(DTAJobController.class);

    private Ip2HttpUtil ip2HttpUtil = new Ip2HttpUtil();

    public String submitDtaJob(Integer searchId){

        logger.info("START");

        String status = "";

        try{
            URI uri = ip2HttpUtil.getURIBuilder().setPath(Ip2Constants.getInstance().getSubmitDtaJobPath())
                    .setParameter("searchId", String.valueOf(searchId))
                    .build();

            String jsonString = ip2HttpUtil.getUriResponse(uri);

            Ip2Response response = new Gson().fromJson(jsonString, Ip2Response.class);

            status = response.getStatus();

            logger.debug("status ::"+status);

        }catch (
                URISyntaxException e) {
            e.printStackTrace();
        }

        logger.info("END");
        return status;
    }

    public static void main(String[] args) {

        AccountController accountController = new AccountController();
        accountController.authenticate("ip2test", "ip2test321");

        DTAJobController dtaJobController = new DTAJobController();
        String status = dtaJobController.submitDtaJob(165680);
        System.out.println("STATUS::"+ status);
    }
}
