package com.ip2.api.controller;

import com.google.gson.Gson;
import com.google.gson.reflect.TypeToken;
import com.ip2.api.Ip2Constants;
import com.ip2.api.bo.MassSpecInstrument;
import com.ip2.api.util.Ip2HttpUtil;
import org.apache.log4j.Logger;

import java.lang.reflect.Type;
import java.net.URI;
import java.net.URISyntaxException;
import java.util.ArrayList;
import java.util.List;

public class MassSpecInstrumentController {

    private static Logger logger = Logger.getLogger(MassSpecInstrumentController.class);

    private Ip2HttpUtil ip2HttpUtil = new Ip2HttpUtil();

    public List<MassSpecInstrument> getMassSpectInstrumenst() {

        List<MassSpecInstrument> massSpecInstruments = new ArrayList<>();

        try {
            URI uri = ip2HttpUtil.getURIBuilder().setPath(Ip2Constants.getInstance().getMassSpectInstrumentPath()).build();

            String jsonString = ip2HttpUtil.getUriResponse(uri);

            Type massSpecInstrument = new TypeToken<List<MassSpecInstrument>>() {
            }.getType();

            massSpecInstruments = new Gson().fromJson(jsonString, massSpecInstrument);

            logger.debug("massSpecInstruments size :: " + massSpecInstruments.size());

        } catch (URISyntaxException e) {
            e.printStackTrace();
        }

        return massSpecInstruments;
    }

    public static void main(String[] args) {

        AccountController accountController = new AccountController();
        accountController.authenticate("ip2test", "ip2test321");
        MassSpecInstrumentController massSpecInstrumentController = new MassSpecInstrumentController();
        System.out.println("Instrument size ::"+massSpecInstrumentController.getMassSpectInstrumenst().size());
    }
}
