package com.ip2.api.controller;

import com.google.gson.Gson;
import com.google.gson.reflect.TypeToken;
import com.ip2.api.Ip2Constants;
import com.ip2.api.bo.Project;
import com.ip2.api.util.Ip2HttpUtil;
import org.apache.log4j.Logger;

import java.lang.reflect.Type;
import java.net.URI;
import java.net.URISyntaxException;
import java.util.ArrayList;
import java.util.List;

public class ProjectController {

    private static Logger logger = Logger.getLogger(ProjectController.class);

    private Ip2HttpUtil ip2HttpUtil = new Ip2HttpUtil();

    public List<Project> getProjects() {

        List<Project> projectList = new ArrayList<>();

        try {

            URI uri = ip2HttpUtil.getURIBuilder().setPath(Ip2Constants.getInstance().getProjectPath()).build();

            String jsonString = ip2HttpUtil.getUriResponse(uri);

//            logger.debug("JSON Value :: "+jsonString);

            Type ip2Projects = new TypeToken<List<Project>>() {
            }.getType();

            projectList = new Gson().fromJson(jsonString,ip2Projects);

            logger.debug("projectList size :: "+projectList.size());

        } catch (URISyntaxException e) {
            e.printStackTrace();
        }

        return projectList;
    }

    public static void main(String[] args) {
        AccountController accountController = new AccountController();
        accountController.authenticate("ip2test", "ip2test321");
        ProjectController projectController = new ProjectController();
        System.out.println("Projects ::"+projectController.getProjects().size());
    }

}
