package com.ip2.api.controller;

import com.google.gson.Gson;
import com.ip2.api.Ip2Constants;
import com.ip2.api.bo.DbSearch;
import com.ip2.api.util.Ip2HttpUtil;
import org.apache.log4j.Logger;

import java.net.URI;
import java.net.URISyntaxException;

public class SearchController {

    private static Logger logger = Logger.getLogger(SearchController.class);

    private Ip2HttpUtil ip2HttpUtil = new Ip2HttpUtil();

    public DbSearch getSearchDetails(Integer searchId) {

        DbSearch dbSearch = null;

        try {
            URI uri = ip2HttpUtil.getURIBuilder().setPath(Ip2Constants.getInstance().getSearchDetailsPath())
                    .setParameter("searchId", String.valueOf(searchId))
                    .build();

            String jsonString = ip2HttpUtil.getUriResponse(uri);

            dbSearch = new Gson().fromJson(jsonString, DbSearch.class);

        } catch (
                URISyntaxException e) {
            e.printStackTrace();
        }

        return dbSearch;
    }

    public static void main(String[] args) {

        AccountController accountController = new AccountController();
        accountController.authenticate("ip2test", "ip2test321");

        SearchController searchController = new SearchController();
        DbSearch dbSearch = searchController.getSearchDetails(164696);
        System.out.println("DBSerach ::"+dbSearch.toString());

    }
}
