package com.ip2.api.controller;

import com.google.gson.JsonObject;
import com.google.gson.JsonParser;
import org.apache.commons.io.IOUtils;
import org.apache.hc.client5.http.classic.methods.HttpGet;
import org.apache.hc.client5.http.classic.methods.HttpPost;
import org.apache.hc.client5.http.entity.UrlEncodedFormEntity;
import org.apache.hc.client5.http.impl.classic.CloseableHttpClient;
import org.apache.hc.client5.http.impl.classic.CloseableHttpResponse;
import org.apache.hc.client5.http.impl.classic.HttpClients;
import org.apache.hc.core5.http.Header;
import org.apache.hc.core5.http.HttpEntity;
import org.apache.hc.core5.http.HttpHeaders;
import org.apache.hc.core5.http.NameValuePair;
import org.apache.hc.core5.http.io.entity.EntityUtils;
import org.apache.hc.core5.http.message.BasicNameValuePair;


import java.io.IOException;
import java.io.InputStream;
import java.net.HttpURLConnection;
import java.net.URL;
import java.nio.charset.StandardCharsets;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class TestController {

    private final CloseableHttpClient httpClient = HttpClients.createDefault();

    public static void main(String[] args) throws IOException {

        TestController obj = new TestController();

        try {
            System.out.println("Testing 1 - Send Http GET request");

            String url = "http://cheezer.scripps.edu:18080/ip2/api/validate.html?userName=ip2test&password=ip2test321";
            String securityCode = obj.sendGet(url);
            System.out.println("securityCode ::" + securityCode);
            String projectUrl = "http://cheezer.scripps.edu:18080/ip2/api/projects.html?securityCode="+securityCode;
            obj.getProjects(projectUrl);

        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            obj.close();
        }
    }

    private void close() throws IOException {
        httpClient.close();
    }

    private String sendGet(String url) throws Exception {

        HttpGet request = new HttpGet(url);

        String result = "";

        // add request headers
        request.addHeader(HttpHeaders.USER_AGENT, "Ip2");

        try (CloseableHttpResponse response = httpClient.execute(request)) {

            // Get HttpResponse Status
            System.out.println(response.getCode());

            HttpEntity entity = response.getEntity();
            String headers = entity.getContentType();
            System.out.println(headers);

            if (entity != null) {
                // return it as a String
                String resonseStr = EntityUtils.toString(entity);
                System.out.println(resonseStr);
                JsonObject jsonObject = new JsonParser().parse(resonseStr).getAsJsonObject();
                result = jsonObject.get("securityCode").getAsString();
                System.out.println(result);
            }

        }

        return result;

    }

    private String getProjects(String url) throws Exception {

        HttpGet request = new HttpGet(url);

        String result = "";

        // add request headers
        request.addHeader(HttpHeaders.USER_AGENT, "Ip2");

        try (CloseableHttpResponse response = httpClient.execute(request)) {

            // Get HttpResponse Status
            System.out.println(response.getCode());

            HttpEntity entity = response.getEntity();
            String headers = entity.getContentType();
            System.out.println(headers);

            if (entity != null) {
                // return it as a String
                InputStream instream = entity.getContent();
                try {
                    result =   IOUtils.toString(instream, StandardCharsets.UTF_8.name());
                    System.out.println("Result ::"+ result);
                } finally {
                    instream.close();
                }

            }

        }

        return result;

    }

    private void sendPost() throws Exception {

        HttpPost post = new HttpPost("https://httpbin.org/post");

        // add request parameter, form parameters
        List<NameValuePair> urlParameters = new ArrayList<>();
        urlParameters.add(new BasicNameValuePair("username", "abc"));
        urlParameters.add(new BasicNameValuePair("password", "123"));
        urlParameters.add(new BasicNameValuePair("custom", "secret"));

        post.setEntity(new UrlEncodedFormEntity(urlParameters));

        try (CloseableHttpClient httpClient = HttpClients.createDefault();
             CloseableHttpResponse response = httpClient.execute(post)) {

            System.out.println(EntityUtils.toString(response.getEntity()));
        }

    }
}
