package com.ip2.api.util;

import com.ip2.api.Ip2Constants;
import org.apache.hc.client5.http.classic.methods.HttpGet;
import org.apache.hc.client5.http.classic.methods.HttpPost;
import org.apache.hc.client5.http.classic.methods.HttpUriRequest;
import org.apache.hc.client5.http.impl.classic.CloseableHttpResponse;
import org.apache.hc.core5.http.HttpEntity;
import org.apache.hc.core5.http.HttpHeaders;
import org.apache.hc.core5.http.ParseException;
import org.apache.hc.core5.http.io.entity.EntityUtils;
import org.apache.hc.core5.net.URIBuilder;

import java.io.IOException;
import java.net.URI;
import java.net.URISyntaxException;

public class Ip2HttpUtil {

    public URIBuilder getURIBuilder() {

        URIBuilder uriBuilder = new URIBuilder();
        uriBuilder.setScheme(Ip2Constants.getInstance().getScheme())
                .setHost(Ip2Constants.getInstance().getHost());

        if (!Ip2Constants.getInstance().getSecurityCode().equals(""))
            uriBuilder.setParameter("securityCode", Ip2Constants.getInstance().getSecurityCode());

        return uriBuilder;
    }


    public String getUriResponse(URI uri){
        HttpUriRequest request = new HttpGet(uri);
        return getUriResponse(request);
    }

    public String getPostUriResponse(URI uri){
        HttpUriRequest request = new HttpPost(uri);
        return getUriResponse(request);
    }


    public String getUriResponse( HttpUriRequest request) {

        try {
            System.out.println("URL:" + request.getUri());
        } catch (URISyntaxException e) {
            e.printStackTrace();
        }

        String responseValue = "";

        try (CloseableHttpResponse response = Ip2Constants.getInstance().getHttpClient().execute(request)) {

            HttpEntity entity = response.getEntity();

            request.addHeader(HttpHeaders.USER_AGENT, "Ip2");

            if (entity != null) {
                responseValue = EntityUtils.toString(entity);

            }

        } catch (IOException | ParseException e) {
            e.printStackTrace();
        }

        return responseValue;
    }
}
