package com.ip2.paser;

import javafx.util.Pair;
import reactor.kafka.receiver.ReceiverRecord;

import java.util.ArrayList;
import java.util.Collections;

public class MessageTracker {

    public int numMsg;
    public int totalSizeOfMsg;
    public ArrayList<Integer> logOfMessages;
    public int lastMessageNum = 0;

    public MessageTracker(){
        numMsg = 0;
        totalSizeOfMsg = 0;
        logOfMessages = new ArrayList<Integer>();
    }

    public void add(ReceiverRecord<String, byte[]> message, int messageNum){
        numMsg++;
        totalSizeOfMsg += message.value().length;
        totalSizeOfMsg += message.key().length();
        logOfMessages.add(messageNum);
    }

    public void add(Pair<String, byte[]> message, int messageNum){
        numMsg++;
        totalSizeOfMsg += message.getValue().length;
        totalSizeOfMsg += message.getKey().length();
        logOfMessages.add(messageNum);
    }

    public void combine(MessageTracker tracker) {
        this.numMsg += tracker.numMsg;
        this.totalSizeOfMsg += tracker.totalSizeOfMsg;
        this.logOfMessages.addAll(tracker.logOfMessages);
    }

    public void printMissedMessages(String threadName){
        Collections.sort(logOfMessages);
        int lastMsg = 0;
        for(int i : logOfMessages){
            if(lastMsg != i - 1){
                System.out.println(threadName + " Missed msg: " + i);
            }
            lastMsg = i;
        }
    }
}
