package com.ip2.paser;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.nio.DoubleBuffer;
import java.util.ArrayList;

public class PrecursorScanParser {

    ArrayList<Precursor> pList = new ArrayList<Precursor>();
    public String id;
    public int ms1ScanNumber;

    public final int sizeOfPrecursor = 13;

    public PrecursorScanParser(byte[] rawData) {
        parsePrecursors(rawData);
    }

    public void parsePrecursors(byte[] rawData){
        DoubleBuffer fBuf = ByteBuffer.wrap(rawData)
                .order(ByteOrder.LITTLE_ENDIAN)
                .asDoubleBuffer();
        double[] spectraArray = new double[fBuf.remaining()];
        fBuf.get(spectraArray);

        for (int i = 0; i < spectraArray.length - (sizeOfPrecursor -1) ; i += sizeOfPrecursor) {
            pList.add(new Precursor(spectraArray, i, sizeOfPrecursor));
        }
    }

    public void print(){
        for( Precursor p: pList){
            p.print();
        }
    }

}
